<template>
  <div>
    <filter-panel/>
    <ob-table
        ref="ob-table"
        :columns="columns"
        :functionalPanel="true"
        :filterButtons="filterButtons"
        @select="onSelection"
        @on-change-filter-button="onChangeFilterButton"

        :remote-opt="{
          method: getCarrierOrders,
          arguments: {
            url: $route.query.tab
          }
        }"
        :remote-trigger="$route.query"
        data-qa="orderListTable"
        class="orders-page"
        :component-unique-key="$uniqueTableKeys.AccountShouldOrders"
    >

      <div slot="typeOrder" slot-scope="{data}">
        <type-order :order="data.item"/>
      </div>
      <div slot="caution" slot-scope="{data}">
        <caution :info="data.item"/>
      </div>
      <div slot="route" slot-scope="{data}">
        <routes
            :start-address="data.item.startAddress"
            :end-address="data.item.endAddress"
            :count="0"
        />
      </div>
      <div slot="isResourceNumber" slot-scope="{data}">
        <registration-number :resourceNumber="data.item.resourceNumber"/>
      </div>

      <table-is-empty slot="noneContent"/>

    </ob-table>
  </div>
</template>

<script>
  import FilterPanel from "../../filterPanel";
  import ObTable from 'common-components/src/obComponents/obTable';
  import commonMethods from '@/mixins/order-list-mixin.js';
  import {statusTitleMap} from '@/mixins/order-list-mixin.js';
  import TypeOrder from "../slots/typeOrder";
  import Caution from "../slots/caution";
  import Routes from "../slots/routes";
  import registrationNumber from "../slots/registrationNumber";
  import TableIsEmpty from "../tableIsEmpty";
  import {DateTime} from "luxon";
  import {formatNumber} from "common-components/src/helpers/common";

  export default {
    name: "debtors",
    components: {
      FilterPanel,
      ObTable,
      TypeOrder,
      Caution,
      Routes,
      registrationNumber,
      TableIsEmpty
    },
    mixins: [
      commonMethods
    ],
    data() {
      return {
        filterButtons: [
          {
            title: 'Все',
            uuid: 'PAYMENT_ALL',
            _isActive: true
          },
          {
            html: '<span style="font-size: 18px; color: red" class="icon inherit clock"/>',
            _isActive: false
          },
          {
            title: 'Сбор документов',
            uuid: 'DOCUMENTS',
            _isActive: false
          },
          {
            title: 'Оплата',
            uuid: 'PAYMENT',
            _isActive: false
          }
        ],
        columns: [
          {
            title: '',
            key: 'typeOrder',
            slotName: 'typeOrder',
            sortDisable: true
          },
          {
            title: '№ заказа перевозчика',
            key: 'number',
            width: 140
          },
          {
            title: 'Внешний № заказа клиента',
            key: '',
            html: ({externalNumber}) => this.transformText(externalNumber)
          },
          {
            title: 'дата создания',
            key: 'createdAt',
            html: (data) => data.createdAt
              ? DateTime.fromISO(data.createdAt).toFormat("dd.MM.yyyy")
              : DateTime.local().toFormat("dd.MM.yyyy"),
          },
          {
            title: 'статус',
            key: 'status',
            html: ({status}) => statusTitleMap[status]
          },
          {
            title: 'Маршрут',
            key: 'fromLocationTitle,toLocationTitle',
            slotName: 'route'
          },
          {
            title: "Тягач",
            key: "resourceNumber",
            width: 220,
            slotName: 'isResourceNumber'
          },
          {
            title: "Водитель",
            key: "fio",
            width: 220,
            html: ({fio}) => fio ? fio : 'Не указан'
          },
          {
            title: 'План: погрузка',
            key: 'pvpDate',
            html: (data) => data.pvpDate
              ? DateTime.fromISO(data.pvpDate).toFormat("dd.MM.yyyy")
              : 'Не указано',
          },
          {
            title: 'сумма без ндс',
            key: 'totalPriceWithoutVat',
            isAlignRight: true,
            html: ({totalPriceWithoutVat}) =>
              `<div class="price-right">
                <span style="white-space: nowrap;">
                  ${formatNumber(totalPriceWithoutVat / 100, {dot: 2}) + " ₽"}
                </span>
              </div>`
          },
          {
            title: this.isTab === "carrier" ? 'НДС перевозчика' : 'ндс',
            key: 'vatValue',
            isAlignRight: true,
            html: ({vatValue}) =>
              `<div class="price-right">
                <span style="white-space: nowrap;">
                  ${formatNumber(vatValue / 100, {dot: 2}) + " ₽"}
                </span>
              </div>`
          },
          {
            title: 'сумма итого',
            key: 'totalPrice',
            isAlignRight: true,
            html: ({totalPrice}) =>
              `<div class="price-right">
                <span style="white-space: nowrap;">
                  ${formatNumber(totalPrice / 100, {dot: 2}) + " ₽"}
                </span>
              </div>`
          }
        ],
        statusTitleMap: statusTitleMap
      }
    }
    /**
     * todo Не удалять этот блок без солгасования с Андреем Рынгачом
     const paymentCommon = [
     {
              title: 'статус',
              key: 'statusTitle'
            },
     {
              title: 'Документы: План. дата',
              html: () => 'В разработке'
            },
     {
              title: 'Документы: Дата в системе',
              html: () => 'В разработке'
            },
     {
              title: 'Документы: Факт. дата',
              html: () => 'В разработке'
            },
     {
              title: 'Документы: Дней просрочки',
              html: () => 'В разработке'
            },
     {
              title: 'Оплата: Всего к оплате',
              html: () => 'В разработке'
            },
     {
              title: 'Оплата: Оплачено',
              html: () => 'В разработке'
            },
     {
              title: 'Оплата: План. дата',
              html: () => 'В разработке'
            },
     {
              title: 'Оплата: Факт. дата',
              html: () => 'В разработке'
            },
     {
              title: 'Оплата: Дней просрочки',
              html: () => 'В разработке'
            },
     {
              title: "Грузовладелец",
              key: "clientTitle",
              slotName: "clientTitle",
              width: 220
            }
     ];
     */
  }
</script>
